import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Properties;

import org.apache.http.client.ClientProtocolException;

import au.com.fax2.*;

public class SendFax {
	private static final String propertiesFilename = "fax2demo.properties";

	public static void run()
		throws ClientProtocolException,IOException,Client.Exception,InterruptedException
	{
		Properties properties = new Properties();
		FileInputStream propertiesFile = new FileInputStream(propertiesFilename);
		properties.load(propertiesFile);
		propertiesFile.close();
		
		String dest_number = properties.getProperty("dest_number");
		
		Client client = new Client(properties);

		ArrayList<String> docs = new ArrayList<String>();
		String doc_id = client.addText("This is the cover page.");
		docs.add(doc_id);
		String doc2_id = client.addDocument(new File("sample.pdf"),"application/pdf");
		docs.add(doc2_id);

		Client.SendFaxResponse fax = client.sendFax(dest_number,docs);
		
		System.out.printf("Fax submitted, id is %s, %d pages\n",fax.id,fax.pages);
		
		Client.FaxStatus result;
		while(true) {
			result  = client.getOutgoingFaxStatus(fax.id);
			
			if(result.status.equals("sent") || result.status.equals("failed")) break;
			Thread.sleep(1000 * 3);
		}
		
		if(result.status.equals("sent")) {
			System.out.printf("Result: success\n");
		} else {
			System.out.printf("Result: failed, reasoun: %s\n",result.reason);
		}
	}

	public static void main(String[] args)
		throws ClientProtocolException,IOException,Client.Exception,InterruptedException
	{
		run();
	}
}
